using System;
using System.Collections.Generic;

using Microsoft.UI;
using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Media;

using Windows.Foundation.Metadata;
using Windows.UI;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ Ʈ - FontList

        /// <summary>
        /// Ʈ Ʈ
        /// </summary>
        public List<Tuple<string, FontFamily>> FontList { get; } = new List<Tuple<string, FontFamily>>()
        {
            new Tuple<string, FontFamily>("Arial"          , new FontFamily("Arial"          )),
            new Tuple<string, FontFamily>("Comic Sans MS"  , new FontFamily("Comic Sans MS"  )),
            new Tuple<string, FontFamily>("Courier New"    , new FontFamily("Courier New"    )),
            new Tuple<string, FontFamily>("Segoe UI"       , new FontFamily("Segoe UI"       )),
            new Tuple<string, FontFamily>("Times New Roman", new FontFamily("Times New Roman"))
        };

        #endregion
        #region Ʈ ũ Ʈ - FontSizeList

        /// <summary>
        /// Ʈ ũ Ʈ
        /// </summary>
        public List<double> FontSizeList { get; } = new List<double>()
        {
            8,
            9,
            10,
            11,
            12,
            14,
            16,
            18,
            20,
            24,
            28,
            36,
            48,
            72
        };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainWindow()

        /// <summary>
        /// 
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.colorComboBox.SelectionChanged += colorComboBox_SelectionChanged;
            this.fontComboBox.Loaded            += fontComboBox_Loaded;
            this.fontSizeComboBox.Loaded        += fontSizeComboBox_Loaded;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  ޺ ڽ   óϱ - colorComboBox_SelectionChanged(sender, e)

        /// <summary>
        ///  ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void colorComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            string colorName = e.AddedItems[0].ToString();

            Color color;

            switch(colorName)
            {
                case "Yellow" : color = Colors.Yellow; break;
                case "Green"  : color = Colors.Green;  break;
                case "Blue"   : color = Colors.Blue;   break;
                case "Red"    : color = Colors.Red;    break;
                default       : throw new Exception($"Invalid argument : {colorName}");
            }

            colorRectangle.Fill = new SolidColorBrush(color);
        }

        #endregion
        #region Ʈ ޺ ڽ ε óϱ - fontComboBox_Loaded(sender, e)

        /// <summary>
        /// Ʈ ޺ ڽ ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void fontComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            this.fontComboBox.SelectedIndex = 2;
        }

        #endregion
        #region Ʈ ũ ޺ ڽ ε óϱ - fontSizeComboBox_Loaded(sender, e)

        /// <summary>
        /// Ʈ ũ ޺ ڽ ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void fontSizeComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            this.fontSizeComboBox.SelectedIndex = 2;

            if((ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7)))
            {
                this.fontSizeComboBox.TextSubmitted += fontSizeComboBox_TextSubmitted;
            }
        }

        #endregion
        #region Ʈ ũ ޺ ڽ ؽƮ  óϱ - fontSizeComboBox_TextSubmitted(sender, e)

        /// <summary>
        /// Ʈ ũ ޺ ڽ ؽƮ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void fontSizeComboBox_TextSubmitted(ComboBox sender, ComboBoxTextSubmittedEventArgs e)
        {
            bool isDouble = double.TryParse(sender.Text, out double newValue);

            if(isDouble && (FontSizeList.Contains(newValue) || (newValue < 100 && newValue > 8)))
            {
                sender.SelectedItem = newValue;
            }
            else
            {
                sender.Text = sender.SelectedValue.ToString();

                ContentDialog dialog = new ContentDialog();

                dialog.Content         = "Ʈ ũ 8 100  ̾ մϴ.";
                dialog.CloseButtonText = "ݱ";
                dialog.DefaultButton   = ContentDialogButton.Close;
                dialog.XamlRoot        = sender.XamlRoot;

                _ = dialog.ShowAsync();
            }

            e.Handled = true;
        }

        #endregion
    }
}